void gcodelines(){
    int gcodeline = 0; 
  
  gcode[gcodeline]= "G28"; gcodeline++; 
  gcode[gcodeline]= "M140 S60"; gcodeline++;   
  gcode[gcodeline]= "M190 S60"; gcodeline++; 
  gcode[gcodeline]= "M104 S220"; gcodeline++; 
  gcode[gcodeline]= "M109 S220"; gcodeline++; 
  gcode[gcodeline]= "M42 P6 S255<FAN>"; gcodeline++; 
  gcode[gcodeline]= "G92 E0"; gcodeline++; 
  gcode[gcodeline]= "T0"; gcodeline++; 
  gcode[gcodeline]= "M104 S220"; gcodeline++; 
  
  FIELD_STEP = gcode_xyzpitch;
  
  int blankcount = 0;

  for(int k = int((resolution-1)*z_scan/100)+1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          //x
          float x = -FIELD_STEP*resolution/2 + FIELD_STEP*(i - 1);
          float xx = -FIELD_STEP*resolution/2 + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float y = -FIELD_STEP*resolution/2+ FIELD_STEP*(j - 1);
          float yy = -FIELD_STEP*resolution/2 + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float z = + FIELD_STEP*(k - 1);
          float zz =  FIELD_STEP*(k);
          float realz =z; 
          
                  //x
          float nx = -FIELD_STEP*resolution/2 + FIELD_STEP*(i );
          float nxx = -FIELD_STEP*resolution/2 + FIELD_STEP*(i + 1);
          float nrealx = (nx + nxx)/2; 
          //y
          float ny = -FIELD_STEP*resolution/2+ FIELD_STEP*(j );
          float nyy = -FIELD_STEP*resolution/2 + FIELD_STEP*(j + 1);
          float nrealy = (ny + nyy)/2; 
          //z
          float nz = + FIELD_STEP*(k );
          float nzz =  FIELD_STEP*(k + 1);
          float nrealz = nz; 
          
          if ( i<resolution) {
           if (  xyzarrays[i-1][j-1][k-1] == 1 &&   xyzarrays[i][j-1][k-1] == 1 ) {
                    gcode[gcodeline]= "G1 X"+realx+ " Y"+realy+ " Z"+realz + " F"+gcode_feedrate;  gcodeline++; 
                    gcode[gcodeline]= "G1 X"+nrealx+" Y"+nrealy+ " Z"+nrealz + " E"+gcode_extrude+" F"+gcode_feedrate;  gcodeline++; 
           }
           
              if (  xyzarrays[i-1][j-1][k-1] == 1 &&   xyzarrays[i][j-1][k-1] == 0 ) {
                      gcode[gcodeline]= "G1 X"+realx+ " Y"+realy+ " Z"+realz + " F"+gcode_feedrate;  gcodeline++; 
                      gcode[gcodeline]= "G1 E"+gcode_extrude; gcodeline++; 
             
           }
          } else { 
           // i = resolution;
             if (  xyzarrays[i-1][j-1][k-1] == 1 ) {
                   gcode[gcodeline]= "G1 X"+realx+ " Y"+realy+ " Z"+realz + " F"+gcode_feedrate;  gcodeline++; 
                   gcode[gcodeline]= "G1 E"+gcode_extrude; gcodeline++; 
             
             }
          }
       }
    }
  }

  gcode[gcodeline]= "M104 S0"; gcodeline++; 
  gcode[gcodeline]= "M190 S0"; gcodeline++;   
  gcode[gcodeline]= "M107"; gcodeline++; 
  gcode[gcodeline]= "M42 P6 S0<FAN>"; gcodeline++; 
  gcode[gcodeline]= "G28"; 
  

  saveStrings(year() + "_" + month() + "_" + day() + "_" + hour() + "_" + minute() + "_" + second() +  "_line" + ".gcode", gcode);

  
}
