PImage[] img = new PImage[maxresolution];

int mri_num = 3;

int[][][] grayScale = new int[maxresolution][maxresolution][maxresolution];

int[][][] grayScale_ratio = new int[maxresolution][maxresolution][maxresolution];

public void MRI_RECONSTRUCTION(){
  
  mri_reconstruction = true;
  
  //load mri images
  for(int k = 1; k <= mri_num; k++){
  img[k-1] = loadImage("MRI_head_side_" + (k-1) +".jpg");
  //image(img[k-1], (k-1)*100, 0);
  img[k-1].loadPixels();
  }
  
  resolution = img[0].width;
  
  println("hello");
   
  for (int k = 1; k <=  mri_num; k++) {
    for (int j = 1; j <= img[k-1].height; j++) {
      for (int i = 1; i <= img[k-1].width; i++) { 
        color c = img[k-1].pixels[(i-1) + (j-1) * img[k-1].width];
        grayScale[i-1][j-1][k-1] = int(red(c) * 0.299 + green(c) * 0.587 + blue(c) * 0.114);
        println((i-1) + " " + (j-1) + " " + (k-1) + " " + grayScale[i-1][j-1][k-1]);
        
       // pushMatrix();
        
     //   translate(100*(k-1), 100);
     //   fill(grayScale[i-1][j-1][k-1]);
     //   rect((i-1), (j-1), 1, 1);
        
     //   popMatrix();



        //グレースケール値を充填度（9段階）に変換
        if (grayScale[i-1][j-1][k-1] < 28) {
          grayScale_ratio[i-1][j-1][k-1] = 0;
        }
        else if (28 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 56) {
          grayScale_ratio[i-1][j-1][k-1] = 1;
        }
        else if (56 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 84) {
          grayScale_ratio[i-1][j-1][k-1] = 2;
        }
        else if (84 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 112) {
          grayScale_ratio[i-1][j-1][k-1] = 3;
        }
        else if (112 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 140) {
          grayScale_ratio[i-1][j-1][k-1] = 4;
        }
        else if (140 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 168) {
          grayScale_ratio[i-1][j-1][k-1] = 5;
        }
        else if (168 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 196) {
          grayScale_ratio[i-1][j-1][k-1] = 6;
        }
        else if (196 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 224) {
          grayScale_ratio[i-1][j-1][k-1] = 7;
        }
        else if (224 <= grayScale[i-1][j-1][k-1] && grayScale[i-1][j-1][k-1] < 256) {
          grayScale_ratio[i-1][j-1][k-1] = 8;
        }
        
      }
    }
  }

  for (int k = 1; k<=mri_num; k = k + 1) {
    for (int j = 1; j<=img[k-1].height; j = j + 1) {
      for (int i = 1; i<=img[k-1].width; i = i + 1) {
        density_ratio[i-1][j-1][k-1] = grayScale_ratio[i-1][j-1][k-1];
      }
    }
  }
  
  //mri_firstScan
  for (int k = 1; k<=mri_num; k = k + 1) {
    for (int j = 1; j<=img[k-1].height; j = j + 1) {
      for (int i = 1; i<=img[k-1].width; i = i + 1) {

        //全てのボクセルでパターンが決まっていない状態からスタート
        found_voxel[i-1][j-1][k-1] = false;

        //saikasou
        if (i-1 == 0) {

          //ratio = 0;
          if (density_ratio[i-1][j-1][k-1] == 0) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts0_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }

          //ratio = 1;
          if (density_ratio[i-1][j-1][k-1] == 1) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts1_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }

          //ratio = 2;
          if (density_ratio[i-1][j-1][k-1] == 2) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts2_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }          

          //ratio = 3;
          if (density_ratio[i-1][j-1][k-1] == 3) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts3_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          } 

          //ratio = 4;
          if (density_ratio[i-1][j-1][k-1] == 4) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts4_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }   

          //ratio = 5;
          if (density_ratio[i-1][j-1][k-1] == 5) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts5_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }   

          //ratio = 6;
          if (density_ratio[i-1][j-1][k-1] == 6) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts6_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }

          //ratio = 7;
          if (density_ratio[i-1][j-1][k-1] == 7) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts7_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }

          //ratio = 8;
          if (density_ratio[i-1][j-1][k-1] == 8) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts8_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }
        }


        //ratio = 0;
        if (density_ratio[i-1][j-1][k-1] == 0) {
          if (found_voxel[i-1][j-1][k-1] == false) {
            txt_arrays[i-1][j-1][k-1] = txts0_scan_first[0];
            found_voxel[i-1][j-1][k-1] = true;
          }
        }

        //ratio = 1;
        if (density_ratio[i-1][j-1][k-1] == 1) {
          for (int auto1 = 0; auto1 < txts1.length; auto1++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts1_scan_first[auto1];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 2;
        if (density_ratio[i-1][j-1][k-1] == 2) {
          for (int auto2 = 0; auto2 < txts2.length; auto2++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts2_scan_first[auto2];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 3;
        if (density_ratio[i-1][j-1][k-1] == 3) {
          for (int auto3 = 0; auto3 < txts3.length; auto3++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts3_scan_first[auto3];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 4;
        if (density_ratio[i-1][j-1][k-1] == 4) {
          for (int auto4 = 0; auto4 < txts4.length; auto4++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts4_scan_first[auto4];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 5;
        if (density_ratio[i-1][j-1][k-1] == 5) {
          for (int auto5 = 0; auto5 < txts5.length; auto5++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts5_scan_first[auto5];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 6;
        if (density_ratio[i-1][j-1][k-1] == 6) {
          for (int auto6 = 0; auto6 < txts6.length; auto6++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts6_scan_first[auto6];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 7;
        if (density_ratio[i-1][j-1][k-1] == 7) {
          for (int auto7 = 0; auto7 < txts7.length; auto7++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts7_scan_first[auto7];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }

        //ratio = 8;
        if (density_ratio[i-1][j-1][k-1] == 8) {
          for (int auto8 = 0; auto8 < txts8.length; auto8++) {
            if (found_voxel[i-1][j-1][k-1] == false) {
              txt_arrays[i-1][j-1][k-1] = txts8_scan_first[auto8];
              //ターゲットの下隣(z-)との接続を判定
              mri_JudgeConnectionFirst(i-1, j-1, k-1);
            }
          }
        }     

        //   if(found_voxel[i-1][j-1][k-1] == true){
        //     println(i + "" + j + "" + k + " " + density_ratio[i][j][k] + " " + "txts_array found" + " " + txt_arrays[i-1][j-1][k-1]);
        //   }
      }
    }
  }
  
  //mri_secondScan
  for (int k = 1; k<=mri_num; k = k + 1) {
    for (int j = 1; j<=img[k-1].height; j = j + 1) {
      for (int i = 1; i<=img[k-1].width; i = i + 1) {
        
          if(found_voxel[i-1][k-1][j-1] == false){
            
            //ratio = 1;
            if(density_ratio[i-1][j-1][k-1] == 1){
              for(int auto1 = 0; auto1 < txts1.length; auto1++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts1_scan_second[auto1];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 2;
            if(density_ratio[i-1][j-1][k-1] == 2){
              for(int auto2 = 0; auto2 < txts2.length; auto2++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts2_scan_second[auto2];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 3;
            if(density_ratio[i-1][j-1][k-1] == 3){
              for(int auto3 = 0; auto3 < txts3.length; auto3++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts3_scan_second[auto3];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 4;
            if(density_ratio[i-1][j-1][k-1] == 4){
              for(int auto4 = 0; auto4 < txts4.length; auto4++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts4_scan_second[auto4];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 5;
            if(density_ratio[i-1][j-1][k-1] == 5){
              for(int auto5 = 0; auto5 < txts5.length; auto5++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts5_scan_second[auto5];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 6;
            if(density_ratio[i-1][j-1][k-1] == 6){
              for(int auto6 = 0; auto6 < txts6.length; auto6++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts6_scan_second[auto6];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 7;
            if(density_ratio[i-1][j-1][k-1] == 7){
              for(int auto7 = 0; auto7 < txts7.length; auto7++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts7_scan_second[auto7];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 8;
            if(density_ratio[i-1][j-1][k-1] == 8){
              for(int auto8 = 0; auto8 < txts8.length; auto8++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts8_scan_second[auto8];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                mri_JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }      
          
          }
        
        
      }
    }
  }
  
  
  //set_dithering_txt_arrays
  for (int k = 1; k<=mri_num; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
          dithering_c[0] = txt_arrays[i-1][j-1][k-1].charAt(4);
          dithering_c[1] = txt_arrays[i-1][j-1][k-1].charAt(5);
          dithering_c[2] = txt_arrays[i-1][j-1][k-1].charAt(6);
          dithering_c[3] = txt_arrays[i-1][j-1][k-1].charAt(7);
          dithering_c[4] = txt_arrays[i-1][j-1][k-1].charAt(0);
          dithering_c[5] = txt_arrays[i-1][j-1][k-1].charAt(1);
          dithering_c[6] = txt_arrays[i-1][j-1][k-1].charAt(2);
          dithering_c[7] = txt_arrays[i-1][j-1][k-1].charAt(3);

          dithering_txt_arrays[i-1][j-1][k-1] = new String(dithering_c);
      }
    }
  }
  
  //set_dithering_xyzarrays
  for (int k = 1; k<= mri_num; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
          int count = 0;
          for (int g = 0; g<2; g = g + 1) {
            for (int f = 0; f<2; f = f + 1) {
              for (int e = 0; e<2; e = e + 1) {
                dithering_xyzarrays[(i-1)*2 + e][(j-1)*2 + f][(k-1)*2 + g] = dithering_txt_arrays[i-1][j-1][k-1].charAt(count) - '0';
                count++;
            }
          }
        }
      }
    }
  }
  
  //set_xyzarrays_for_drawing
  for (int k = 1; k<=mri_num*2; k = k + 1) {
    for (int j = 1; j<=resolution*2; j = j + 1) {
      for (int i = 1; i<=resolution*2; i = i + 1) {
        xyzarrays[i-1][j-1][k-1] = dithering_xyzarrays[i-1][j-1][k-1];
      }
    }
  }
  
    for (int k = 1; k<=resolution; k = k + 1) {
     for (int j = 1; j<=resolution; j = j + 1) {
       for (int i = 1; i<=resolution; i = i + 1) { 
         if(found_voxel[i-1][j-1][k-1] == true){   
            println((i-1) + " " + (j-1) + " " + (k-1) + " " + density_ratio[i-1][j-1][k-1] + " " + "txts_array found" + " " + txt_arrays[i-1][j-1][k-1]);
           }
           
      }
    }
  }
 
  
}

//ターゲットの下隣(z-)との接続を判定
public void mri_JudgeConnectionFirst(int i, int j, int k) {

  if (k != 0) {
    //ターゲットの下隣(z-)との接続を判定
    if (   (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i][j][k-1].charAt(3) == '1')
      || (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i][j][k-1].charAt(2) == '1')
      || (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i][j][k-1].charAt(1) == '1')    
      || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i][j][k-1].charAt(0) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts8_scan_first[0];
    }
  }
}

//ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
public void mri_JudgeConnectionSecond(int i, int j, int k) {

  if (i != 0) {
    //ターゲットの左隣(x-)との接続を判定 
    if (   (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i-1][j][k].charAt(6) == '1')
      || (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i-1][j][k].charAt(2) == '1')
      || (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i-1][j][k].charAt(4) == '1')    
      || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i-1][j][k].charAt(0) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts0_scan_second[0];
    }
  }

  if (i != img[k].width-1) {
    //ターゲットの右隣(x+)との接続を判定   
    if (   (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i+1][j][k].charAt(7) == '1')
      || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i+1][j][k].charAt(3) == '1')
      || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i+1][j][k].charAt(5) == '1')    
      || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i+1][j][k].charAt(1) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts0_scan_second[0];
    }
  }        

  if (j != 0) {
    //ターゲットの前隣(y-)との接続を判定 
    if (   (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i][j-1][k].charAt(5) == '1')
      || (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i][j-1][k].charAt(4) == '1')
      || (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i][j-1][k].charAt(1) == '1')    
      || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i][j-1][k].charAt(0) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts0_scan_second[0];
    }
  }

  if (j != img[k].height-1) {
    //ターゲットの後隣(y+)との接続を判定
    if (   (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i][j+1][k].charAt(7) == '1')
      || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i][j+1][k].charAt(6) == '1')
      || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i][j+1][k].charAt(3) == '1')    
      || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i][j+1][k].charAt(2) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts0_scan_second[0];
    }
  } 

  if (k != mri_num-1) {
    //ターゲットの上隣(z+)との接続を判定
    if (   (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i][j][k+1].charAt(7) == '1')
      || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i][j][k+1].charAt(6) == '1')
      || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i][j][k+1].charAt(5) == '1')    
      || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i][j][k+1].charAt(4) == '1') ) {
      found_voxel[i][j][k] = true;
    }
    else {
      found_voxel[i][j][k] = false;
      txt_arrays[i][j][k] = txts0_scan_second[0];
    }
  }
}



