import java.io.*;
String result;

void DO_CCX() {
  try {

    Runtime r = Runtime.getRuntime();
        println("ccx "+workdir+filename);
    String [] command  = {
      batchfiledir, "ccx", workdir+filename
    };
    Process process =  Runtime.getRuntime().exec(command);   
    InputStream is = process.getInputStream();
    InputStreamReader isr = new InputStreamReader(is);
    BufferedReader br = new BufferedReader(isr);
    while ( (result = br.readLine ()) != null) {
      //      System.out.println(result);
    }
  } 
  catch (IOException ex) {
    ex.printStackTrace();
  }
}

void DO_CGX() {
  try {

    Runtime r = Runtime.getRuntime();
        println("cgx "+workdir+filename);
    String [] command  = {
      batchfiledir, "cgx", "-v", workdir+filename+".frd"
    };
    Process process =  Runtime.getRuntime().exec(command);
    InputStream is = process.getInputStream();


    InputStreamReader isr = new InputStreamReader(is);
    BufferedReader br = new BufferedReader(isr);
    while ( (result = br.readLine ()) != null) {
      //      System.out.println(result);
    }
  } 
  catch (IOException ex) {
    ex.printStackTrace();
  }
}


void LOAD_CCX() {
  String[] m1;

  mises = new String[1000000];
  for (int qw=0; qw<mises.length; qw++) {
    mises[qw]="";
  }
  mp= new double[resolution*resolution*resolution];
  for (int qww=0; qww<mp.length; qww++) {
    mp[qww]=0;
  }

  mises = loadStrings(workdir+filename+".dat");
  int ij=0;
  for (ij=0; ij<mises.length; ij++) {
    m1 = match(mises[ij], "stresses");
    if (m1 != null) { 
      break;
    }
  } 

  int startline = ij+2;
  float ppmin = 1000000;
  float ppmax = 0;
  int pnum = 0;
  float sxx = 0;
  float syy = 0;
  float szz = 0;
  float sxy = 0;
  float sxz = 0;
  float syz = 0;

  // println(mises[startline+8000]);

  ij=startline; 
  while (match (mises[ij+9], "strains")==null) {
    ij=ij+1;
    float startnum = 0;
    for (int ijj=0; ijj<8; ijj++) {
      String[] p = splitTokens(mises[ij+ijj]);
      //println(ij-startline); 
      //println(ijj);
      //println(ij+ijj - startline);
      //println("---------------");
      //println(p);
      //sxx,syy,szz,sxy,sxz,syz
      pnum = int(p[0]);
      sxx = float(p[2]);
      syy = float(p[3]);
      szz = float(p[4]);
      sxy = float(p[5]);
      sxz = float(p[6]);
      syz = float(p[7]);

      startnum = startnum + sqrt(0.5*((sxx-syy)*(sxx-syy)+(syy-szz)*(syy-szz)+(szz-sxx)*(szz-sxx)+3*(sxy*sxy+sxz*sxz+sxy*sxy+syz*syz+sxz*sxz+syz*syz)));
    }
    if (pnum == 1) { 
      ppmin = startnum; 
      ppmax = startnum;
    }

    if (startnum < ppmin && startnum > 0.0 && p[pnum-1].getstate() == 1) { 
      ppmin = startnum;
    }
    if (startnum > ppmax && p[pnum-1].getstate() == 1) { 
      ppmax = startnum;
    }

    if ( p[pnum-1].getstate() == 1) {
      mp[pnum-1] = startnum;
    } 
    else {
      mp[pnum-1] = -1;
    }
  }


  int upper=0, lower=10000;
  for (int iijj=0; iijj<mp.length; iijj++) {



    //  println(mp[iijj]+" --- "+ abc);
    //        if( mp[iijj] == ppmax ) { println ("***** max ****** "+ppmax); }
    //        if( mp[iijj] == ppmin ) { println ("***** min ****** "+ppmin); }



    if ( mp[iijj] != 0.0) {
      // absolutely

      p[iijj].setmag((int)mp[iijj]/2);
      p[iijj].setstate(1); 
      upper = max(upper, (int)mp[iijj]/2);
      lower = min(lower, (int)mp[iijj]/2);
      // relatively
      //  p[iijj].setmag((float)abc * 100* 255);  
      //println(mp[iijj] + "..." + upper + " /// " + lower + " === "+(float)abc * 100 );
    } 
    else {
      p[iijj].setmag(0.0);
    }
  }
  println("upper= "+upper+"   lower="+lower);
}


int REMOVE_MIN() {
  int removenum = 0;
  int nnum=0;
  for ( int k=0; k<resolution; k++) { 
    for (int j=0; j<resolution; j++) { 
      for (int i=0; i<resolution; i++) {      
        if (  p[nnum].magvalue < THRESHOLD_MIN && p[nnum].getstate() ==1) {       
            
          p[nnum].setstate(0);
          xyzarrays[k][j][i]=0;
            //println(removenum + " ... "+p[nnum].getstate());
          removenum = removenum + 1;
        } 
        nnum=nnum+1;
      }
    }
  }
println(removenum);
return(removenum);
}


int REMOVE_MAX() {
  int removenum = 0;
  int nnum=0;
  for ( int k=0; k<resolution; k++) { 
    for (int j=0; j<resolution; j++) { 
      for (int i=0; i<resolution; i++) {      
        if (  p[nnum].magvalue > THRESHOLD_MAX && p[nnum].getstate() ==1) {               
          p[nnum].setstate(0);
          xyzarrays[k][j][i]=0;
          removenum = removenum + 1;
        } 
        nnum=nnum+1;
      }
    }
  }
println(removenum);
return(removenum);
}


  
int RUN_THROUGH_2() {

  int GROWTHresultnum = 0;

  for (int u=0; u<GROWTHnum.length; u++) { 
    GROWTHnum[u]=-1;
  }

  int currentNum = 0;
  int tempPotential;
  float lambda = 0.9;
  for ( int k=0; k<resolution; k++) { 
    for (int j=0; j<resolution; j++) { 
      for (int i=0; i<resolution; i++) {      
        currentNum = i+resolution*j+(resolution*resolution)*k;
        tempPotential = 0;
        if (k>0        && p[i+resolution*j+(resolution*resolution)*(k-1)].getstate() != 2 && p[i+resolution*j+(resolution*resolution)*(k-1)].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (k<resolution-1 && p[i+resolution*j+(resolution*resolution)*(k+1)].getstate() != 2 && p[i+resolution*j+(resolution*resolution)*(k+1)].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (j>0        && p[i+resolution*(j-1)+(resolution*resolution)*k].getstate() != 2 && p[i+resolution*(j-1)+(resolution*resolution)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (j<resolution-1 && p[i+resolution*(j+1)+(resolution*resolution)*k].getstate() != 2 && p[i+resolution*(j+1)+(resolution*resolution)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (i>0        && p[(i-1)+resolution*j+(resolution*resolution)*k].getstate() != 2 && p[(i-1)+resolution*j+(resolution*resolution)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (i<resolution-1 && p[(i+1)+resolution*j+(resolution*resolution)*k].getstate() != 2 && p[(i+1)+resolution*j+(resolution*resolution)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (p[currentNum].getstate() != 0 && p[currentNum].magvalue < THRESHOLD_MIN) {
          tempPotential--;
        }    
        p[currentNum].potential = tempPotential;//lambda*p[currentNum].potential + tempPotential;
      }
    }
  }

  for (int u=0; u<p.length; u++) { 
    if (p[u].potential > 0 && p[u].getstate() == 2) {
      p[u].setstate(1); 
      GROWTHresultnum = GROWTHresultnum + 1;
    }
    else if (p[u].potential <= 0 && p[u].getstate() == 1) {
      p[u].setstate(2); 
      GROWTHresultnum = GROWTHresultnum + 1;
    }
  }
  numberOfSteps++;
  return GROWTHresultnum;
}


void WRITE_INP() {

  int linee=0;
  st = new String[1000000]; 
  for (int qq=0; qq<st.length; qq++) {
    st[qq]="";
  }
  FIELD_STEP = FIELD_SIZE*2/resolution;
  st[linee] = "*node,NSET=NALL";
  linee = linee+1; 
  int nnum=1;
  for ( int i=0; i<resolution+1; i++) { 
    for (int j=0; j<resolution+1; j++) { 
      for (int k=0; k<resolution+1; k++) {        
          float xx,yy,zz;
          if(resolution % 2 ==1){
         xx = -FIELD_STEP*((resolution-1)/2)-FIELD_STEP/2 + FIELD_STEP*(i);
         zz = FIELD_STEP*((resolution-1)/2)+FIELD_STEP/2 - FIELD_STEP*(j);
         yy = FIELD_STEP*((resolution-1)/2)+FIELD_STEP/2 -  FIELD_STEP*(k);  
          } else {
           xx =  -FIELD_STEP*(resolution/2) + FIELD_STEP*(i);
           zz =  FIELD_STEP*(resolution/2) - FIELD_STEP*(j);
           yy =  FIELD_STEP*(resolution/2) - FIELD_STEP*(k);                       
          }
          
          st[linee] = nnum + "," + xx +","+ yy+","+zz;
          //  st[linee] = nnum + "," + i*FIELD_STEP +","+j*FIELD_STEP+","+k*FIELD_STEP;
            nnum=nnum+1;       
        linee=linee+1;
      }
    }
  }

  st[linee] = "*element,TYPE=C3D8,Elset=EALL";
  linee = linee+1;

  nnum=1;
  int dd = 0;
  for ( int i=0; i<resolution; i++) { 
    for (int j=0; j<resolution; j++) { 
      for (int k=0; k<resolution; k++) {      

        if (p[k+j*resolution+i*resolution*resolution].getstate() == 1) {
          dd = 1+k+j*(resolution+1)+i*(resolution+1)*(resolution+1);
          st[linee] = nnum + "," + int(dd) + ","+ int(dd+1) + "," + int(dd+(resolution+2)) + "," +int(dd+(resolution+1)) + "," + int(dd+(resolution+1)*(resolution+1)) + ","+ int(dd+(resolution+1)*(resolution+1)+1) + "," + int(dd+(resolution+1)*(resolution+1)+(resolution+2)) +","+ int(dd+(resolution+1)*(resolution+1)+(resolution+1));
          linee=linee+1;
          nnum=nnum+1;
        }
       // nnum=nnum+1;
      }
    }
  }

  float density = 0.5;

  st[linee] = "*MATERIAL, Name=mat1";
  linee = linee+1;
 // st[linee] = "*DENSITY";
 // linee = linee+1;
 // st[linee] = density + "";
  linee = linee+1;
  st[linee] = "*ELASTIC";
  linee = linee+1;
  st[linee] = elastic01 + "," + elastic02;
  linee = linee+1;
  st[linee] = "*SOLID SECTION, Elset=EALL, Material=mat1";
  linee = linee+1;
  st[linee] = "*STEP";
  linee = linee+1;
  st[linee] = "*STATIC";
  linee = linee+1;
  st[linee] = "*boundary";
  linee = linee+1;


  for ( int i=0; i<resolution; i++) { 
    for (int j=0; j<resolution; j++) { 
      for (int k=0; k<resolution; k++) { 

        if (p[k+j*resolution+i*(resolution)*(resolution)].getstate() == 9) {
          dd = 1+k+j*(resolution+1)+i*(resolution*resolution+1);
          //   st[linee] = nnum + "," + int(dd) + ","+ int(dd+1) + "," + int(dd+12) + "," +int(dd+11) + "," + int(dd+121) + ","+ int(dd+122) + "," + int(dd+133) +","+ int(dd+132);

          //st[linee] = int(dd)+",2,2";  
           st[linee] = int(dd)+",1,1";           
          linee=linee+1;
          st[linee] = int(dd+1)+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1)+1)+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1))+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1))+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+1)+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+(resolution+1)+1)+",1,1";              
          linee=linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+(resolution+1))+",1,1";              
          linee=linee+1;
        }
      }
    }
  }

  st[linee] = "*CLOAD";
  linee = linee+1;
  int sw = 0;
  double spal = 0;
  int tmp = 100;
  for ( int i=0; i<resolution; i++) { 
    for (int j=0; j<resolution; j++) { 
      for (int k=0; k<resolution; k++) {      

        sw= 0;
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 3) { 
          sw = 1; 
          spal = BURDEN/tmp;
        }
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 4) { 
          sw = 1; 
          spal = -BURDEN/tmp;
        }
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 5) { 
          sw = 2; 
          spal = BURDEN/tmp;
        }      
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 6) { 
          sw = 2; 
          spal = -BURDEN/tmp;
        } 
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 7) { 
          sw = 3; 
          spal = +BURDEN/tmp;
        }      
        if (p[k+j*(resolution)+i*resolution*resolution].getstate() == 8) { 
          sw = 3; 
          spal = -BURDEN/tmp;
        }   

        if (sw != 0) {
           dd = 1+k+j*(resolution+1)+i*(resolution+1)*(resolution+1);
         //dd = k+j*(resolution+1)+i*(resolution+1)*(resolution+1);
          st[linee] = int(dd)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1)+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1))+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1))+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+(resolution+1)+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(resolution+1)*(resolution+1)+(resolution+1))+","+sw+","+spal;
          linee = linee+1;
        }
      }
    }
  }



  st[linee] = "*NODE FILE";
  linee = linee+1;
  st[linee] = "U";
  linee = linee+1;
  st[linee] = "*EL FILE";
  linee = linee+1;
  st[linee] = "S,E";
  linee = linee+1;
  st[linee] = "*NODE PRINT, NSET=NALL";
  linee = linee+1;
  st[linee] = "U";
  linee = linee+1;
  st[linee] = "*EL PRINT, ELSET=EALL";
  linee = linee+1;
  st[linee] = "S,E";
  linee = linee+1;
  
  st[linee] = "*END STEP";

  filename= str(year())+"_"+str(month())+"_"+str(day())+"_"+str(hour())+"_"+str(minute())+"_"+str(second());
  saveStrings(workdir+filename+".inp", st);
  println(workdir+filename+".inp");
}

void STOP() {
  evolution = 0;
  println("stop evolution now.");
}

void RUN_THROUGH() {
  WRITE_INP();
  DO_CCX();
  LOAD_CCX();
}
void auto() {
  WRITE_INP();
  DO_CCX();
  LOAD_CCX();
  int m = REMOVE_MAX();
  int mm = REMOVE_MIN();
  if (m==0 && mm==0){ STOP();}
  redraw();
}

void AUTO_EVOLVE() {

  evolution = 1;
}

void DOEVOLUTION() {
  WRITE_INP();
  DO_CCX();
  LOAD_CCX();

  //int evor = REMOVE();
  //int evorr = RUN_THROUGH();
  //return  evorr;
}

public int[] HSVtoRGB(int h, int s, int v){
        float f;
        int i, p, q, t;
        int[] rgb = new int[3];
        h = h*360/255;
        i = (int)Math.floor(h / 60.0f) % 6;
        f = (float)(h / 60.0f) - (float)Math.floor(h / 60.0f);
        p = (int)Math.round(v * (1.0f - (s / 255.0f)));
        q = (int)Math.round(v * (1.0f - (s / 255.0f) * f));
        t = (int)Math.round(v * (1.0f - (s / 255.0f) * (1.0f - f)));
        
        switch(i){
            case 0 : rgb[0] = v; rgb[1] = t; rgb[2] = p; break;
            case 1 : rgb[0] = q; rgb[1] = v; rgb[2] = p; break;
            case 2 : rgb[0] = p; rgb[1] = v; rgb[2] = t; break;
            case 3 : rgb[0] = p; rgb[1] = q; rgb[2] = v; break;
            case 4 : rgb[0] = t; rgb[1] = p; rgb[2] = v; break;
            case 5 : rgb[0] = v; rgb[1] = p; rgb[2] = q; break;
        }

        return rgb;
    }



