class Cell {
        int cx, cy, cz;
        int len;
        int rcol,bcol,gcol,tra;
        int corelen;
        int corecol;
        int state; 
        float tmx, tmi;
        float magvalue;
        // state 0:VOID   1:block 2:void 3: load+x 4: load-x  5:load+y 6:load-y 7:load+z 8:load-z 
        float potential;
        
        Cell(int zz, int yy, int xx, int len, float magg) {
                this.cx = xx;
                this.cy = yy;
                this.cz = zz;
                this.len = len;
                this.rcol = 255;
                this.bcol = 0;
                this.gcol = 0;
                this.tra  = 255;
                this.magvalue = magg;
                this.state = 0;                
                this.potential = 0;
        }

        void setstate(int j){
          this.state=j;        
        }
        
        void setmag(float o){
          this.magvalue = o;
          if (int(o)>126) {      
          this.rcol = HSVtoRGB(int(o)-126,255,255)[0];    
          this.gcol = HSVtoRGB(int(o)-126,255,255)[1];
          this.bcol = HSVtoRGB(int(o)-126,255,255)[2];  
          } 
       if (int(o)<=126) {     
          this.rcol = HSVtoRGB(int(o)+126,255,255)[0];    
          this.gcol = HSVtoRGB(int(o)+126,255,255)[1];
          this.bcol = HSVtoRGB(int(o)+126,255,255)[2];  
          } 

        }
        
        void change(int j){
           if ( cx== mx && cy==my && cz==mz) {
          this.state=j; 
           }
        }
        
           void changex(int j){
           if ( cx== mx ) {
          this.state=j; 
           }
        }
            void changey(int j){
           if ( cy== my ) {
          this.state=j; 
           }
        }
             void changez(int j){
           if ( cz== mz ) {
          this.state=j; 
           }
        }
        
        int getstate() {
          return state;
        }
        
        String getparam() {
          String s = null;
         if ( cx== mx && cy==my && cz==mz) {
          s= "magvalue:"+magvalue+ " - state:"+state;
             }
          return s;
        
        }

        
        void display(int t, float thres_min, float thres_max) {
            tra = t;
            tmi = thres_min;
            tmx = thres_max;

                            
    if (tmi <= magvalue && magvalue <= tmx && state ==1) {               
                fill(rcol,gcol,bcol,tra);

                } 
     if (tmi > magvalue &&  state == 1) {               
                fill(0,0,255,255);

                } 
                
        if (tmx < magvalue &&  state ==1) {               
                fill(255,0,0,255); 

                }  
  
        if (3 <=state && state <=8) { 
                fill(255,0,255,255);        
                }  
         if (state ==9) {  
                fill(155,155,155,255);
   
                }
          if (state ==0) {         
                }  
                
            if(state != 0){  
                
                pushMatrix();
                translate(cx,cy,cz);          
                stroke(0,30);
                box(len,len,len);
               
                popMatrix();
                 }
        }
}
