// start - line segment start point
// end - line segment end point
// boxmin - lower corner aabb
// boxmin - upper corner aabb
// returns true if line segment intersects with aabb
public boolean intersect(PVector start, PVector end, PVector boxmin, PVector boxmax) {   
    float st;
    float et;
    float fst = 0;
    float fet = 1;
    float si;
    float ei;
    float bmin;
    float bmax;
    float time;
    
    bmin = boxmin.x;
    bmax = boxmax.x;
     
    si = start.x;
    ei = end.x;
    
    if (si < ei) {         
      if ((si > bmax) || (ei < bmin))  {
        return false;
      }

      float di = ei - si;
      if (si < bmin) {
          st = (bmin - si) / di;
      } else {
          st = 0;
      }
      
      if (ei > bmax) {
          et = (bmax - si) / di;
      } else {
          et = 1;
      }      
      
    } else {
      if ((ei > bmax) || (si < bmin)) {
        return false;         
      }
      
      float di = ei - si;
      if (si > bmax) {
          st = (bmax - si) / di;
      } else {
          st = 0;
      }
      
      if (ei < bmin) {
          et = (bmin - si) / di;
      } else {
          et = 1;
      }      
    }

    if (st > fst) {
        fst = st;
    }
    if (et < fet) {
        fet = et;      
    }
    if (fet < fst) {
        return false;      
    }
    
    bmin = boxmin.y;
    bmax = boxmax.y;
     
    si = start.y;
    ei = end.y;
    
    if (si < ei) {         
      if ((si > bmax) || (ei < bmin))  {
        return false;
      }

      float di = ei - si;
      if (si < bmin) {
          st = (bmin - si) / di;
      } else {
          st = 0;
      }
      
      if (ei > bmax) {
          et = (bmax - si) / di;
      } else {
          et = 1;
      }      
      
    } else {
      if ((ei > bmax) || (si < bmin)) {
        return false;         
      }
      
      float di = ei - si;
      if (si > bmax) {
          st = (bmax - si) / di;
      } else {
          st = 0;
      }
      
      if (ei < bmin) {
          et = (bmin - si) / di;
      } else {
          et = 1;
      }      
    }

    if (st > fst) {
        fst = st;
    }
    if (et < fet) {
        fet = et;      
    }
    if (fet < fst) {
        return false;      
    }
    
    bmin = boxmin.z;
    bmax = boxmax.z;
     
    si = start.z;
    ei = end.z;
    
    if (si < ei) {         
      if ((si > bmax) || (ei < bmin))  {
        return false;
      }

      float di = ei - si;
      if (si < bmin) {
          st = (bmin - si) / di;
      } else {
          st = 0;
      }
      
      if (ei > bmax) {
          et = (bmax - si) / di;
      } else {
          et = 1;
      }      
      
    } else {
      if ((ei > bmax) || (si < bmin)) {
        return false;         
      }
      
      float di = ei - si;
      if (si > bmax) {
          st = (bmax - si) / di;
      } else {
          st = 0;
      }
      
      if (ei < bmin) {
          et = (bmin - si) / di;
      } else {
          et = 1;
      }      
    }

    if (st > fst) {
        fst = st;
    }
    if (et < fet) {
        fet = et;      
    }
    if (fet < fst) {
        return false;      
    }
    

    time = fst;

    return true;
}

