public void WHOLE_UNIFORM_DITHERING() { 

  voxelize_divide = false;

  whole_uniform_dithering = true;
}

public void INNER_UNIFORM_DITHERING() { 

  voxelize_divide = false;

  inner_uniform_dithering = true;
}

public void INNER_RANDOM_DITHERING() { 

  voxelize_divide = false;

  inner_random_dithering = true;
  
  set_inner_random_density_ratio();
  
}

public void set_whole_uniform_density_ratio() {

  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {     
        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1 || voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) { 
   
          density_ratio[i-1][j-1][k-1] = dithering_uniform_density;
          
          if (density_ratio[i-1][j-1][k-1] == 0) {
            txt_arrays[i-1][j-1][k-1] = "00000000";
          }   
          if (density_ratio[i-1][j-1][k-1] == 1) {
            txt_arrays[i-1][j-1][k-1] = "00000001";
          }    
          if (density_ratio[i-1][j-1][k-1] == 2) {
            txt_arrays[i-1][j-1][k-1] = "00010001";
          }    
          if (density_ratio[i-1][j-1][k-1] == 3) {
            txt_arrays[i-1][j-1][k-1] = "00010011";
          }    
          if (density_ratio[i-1][j-1][k-1] == 4) {
            txt_arrays[i-1][j-1][k-1] = "00011011";
          }    
          if (density_ratio[i-1][j-1][k-1] == 5) {
            txt_arrays[i-1][j-1][k-1] = "11101100";
          }
          if (density_ratio[i-1][j-1][k-1] == 6) {
            txt_arrays[i-1][j-1][k-1] = "10111011";
          }
          if (density_ratio[i-1][j-1][k-1] == 7) {
            txt_arrays[i-1][j-1][k-1] = "11110111";
          }
          if (density_ratio[i-1][j-1][k-1] == 8) {
            txt_arrays[i-1][j-1][k-1] = "11111111";
          }
        }
      }
    }
  }
}


public void set_inner_uniform_density_ratio() {

  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {    

        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1) {
          txt_arrays[i-1][j-1][k-1] = "11111111";
        }

        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) {
  
          density_ratio[i-1][j-1][k-1] = dithering_uniform_density;
          
          if (density_ratio[i-1][j-1][k-1] == 0) {
            txt_arrays[i-1][j-1][k-1] = "00000000";
          }   
          if (density_ratio[i-1][j-1][k-1] == 1) {
            txt_arrays[i-1][j-1][k-1] = "00000001";
          }    
          if (density_ratio[i-1][j-1][k-1] == 2) {
            //txt_arrays[i-1][j-1][k-1] = "00010001";
            txt_arrays[i-1][j-1][k-1] = "00000011";
          }    
          if (density_ratio[i-1][j-1][k-1] == 3) {
            txt_arrays[i-1][j-1][k-1] = "00010011";
          }    
          if (density_ratio[i-1][j-1][k-1] == 4) {
           // txt_arrays[i-1][j-1][k-1] = "00011011";
            txt_arrays[i-1][j-1][k-1] = "00001111";
          }    
          if (density_ratio[i-1][j-1][k-1] == 5) {
            txt_arrays[i-1][j-1][k-1] = "11101100";
          }
          if (density_ratio[i-1][j-1][k-1] == 6) {
            txt_arrays[i-1][j-1][k-1] = "10111011";
          }
          if (density_ratio[i-1][j-1][k-1] == 7) {
            txt_arrays[i-1][j-1][k-1] = "11110111";
          }
          if (density_ratio[i-1][j-1][k-1] == 8) {
            txt_arrays[i-1][j-1][k-1] = "11111111";
          }        

        }
      }
    }
  }
}


public void set_inner_random_density_ratio() {
  
  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {   
        
        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1) {
          txt_arrays[i-1][j-1][k-1] = "11111111";
        }
        
      }
    }
  }
  
        
  for (int k = z_min; k<=z_max; k = k + 1) {
    for (int j = y_min; j<=y_max; j = j + 1) {
      for (int i = x_min; i<=x_max; i = i + 1) {  

        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) {
          density_ratio[i-1][j-1][k-1] = int(random(dithering_random_density_min, dithering_random_density_max));     
        }
        
      }
    }
  }
  
}


//走査1回目
public void firstScan(){
  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
        
        //全てのボクセルでパターンが決まっていない状態からスタート
        found_voxel[i-1][j-1][k-1] = false;
        
        //表面
        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1) {
          //ratio = 8
          if (density_ratio[i-1][j-1][k-1] == 8) {
            txt_arrays[i-1][j-1][k-1] = txts8_scan_first[0];
            found_voxel[i-1][j-1][k-1] = true;
          }     
        }
        
        //内部
        if(voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) {
          
          //ratio = 0;
          if(density_ratio[i-1][j-1][k-1] == 0){
            if(found_voxel[i-1][j-1][k-1] == false){
              txt_arrays[i-1][j-1][k-1] = txts0_scan_first[0];
              found_voxel[i-1][j-1][k-1] = true;
            }
          }
          
          //ratio = 1;
          if(density_ratio[i-1][j-1][k-1] == 1){
            for(int auto1 = 0; auto1 < txts1.length; auto1++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts1_scan_first[auto1];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 2;
          if(density_ratio[i-1][j-1][k-1] == 2){
            for(int auto2 = 0; auto2 < txts2.length; auto2++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts2_scan_first[auto2];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 3;
          if(density_ratio[i-1][j-1][k-1] == 3){
            for(int auto3 = 0; auto3 < txts3.length; auto3++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts3_scan_first[auto3];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 4;
          if(density_ratio[i-1][j-1][k-1] == 4){
            for(int auto4 = 0; auto4 < txts4.length; auto4++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts4_scan_first[auto4];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 5;
          if(density_ratio[i-1][j-1][k-1] == 5){
            for(int auto5 = 0; auto5 < txts5.length; auto5++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts5_scan_first[auto5];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 6;
          if(density_ratio[i-1][j-1][k-1] == 6){
            for(int auto6 = 0; auto6 < txts6.length; auto6++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts6_scan_first[auto6];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 7;
          if(density_ratio[i-1][j-1][k-1] == 7){
            for(int auto7 = 0; auto7 < txts7.length; auto7++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts7_scan_first[auto7];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }
        
          //ratio = 8;
          if(density_ratio[i-1][j-1][k-1] == 8){
            for(int auto8 = 0; auto8 < txts8.length; auto8++){
              if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts8_scan_first[auto8];
                //ターゲットの下隣(z-)との接続を判定
                JudgeConnectionFirst(i-1,j-1,k-1);
            }
          }
        }     
     
     //   if(found_voxel[i-1][j-1][k-1] == true){
     //     println(i + "" + j + "" + k + " " + density_ratio[i][j][k] + " " + "txts_array found" + " " + txt_arrays[i-1][j-1][k-1]);
     //   }   
          
        }
        
        

                        
      }
    }
  }
  
}

//走査2回目
public void secondScan(){
  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
        
        //内部
        if(voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2){
          if(found_voxel[i-1][k-1][j-1] == false){
            
            //ratio = 1;
            if(density_ratio[i-1][j-1][k-1] == 1){
              for(int auto1 = 0; auto1 < txts1.length; auto1++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts1_scan_second[auto1];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 2;
            if(density_ratio[i-1][j-1][k-1] == 2){
              for(int auto2 = 0; auto2 < txts2.length; auto2++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts2_scan_second[auto2];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 3;
            if(density_ratio[i-1][j-1][k-1] == 3){
              for(int auto3 = 0; auto3 < txts3.length; auto3++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts3_scan_second[auto3];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 4;
            if(density_ratio[i-1][j-1][k-1] == 4){
              for(int auto4 = 0; auto4 < txts4.length; auto4++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts4_scan_second[auto4];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 5;
            if(density_ratio[i-1][j-1][k-1] == 5){
              for(int auto5 = 0; auto5 < txts5.length; auto5++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts5_scan_second[auto5];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 6;
            if(density_ratio[i-1][j-1][k-1] == 6){
              for(int auto6 = 0; auto6 < txts6.length; auto6++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts6_scan_second[auto6];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 7;
            if(density_ratio[i-1][j-1][k-1] == 7){
              for(int auto7 = 0; auto7 < txts7.length; auto7++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts7_scan_second[auto7];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }
        
            //ratio = 8;
            if(density_ratio[i-1][j-1][k-1] == 8){
              for(int auto8 = 0; auto8 < txts8.length; auto8++){
                if(found_voxel[i-1][j-1][k-1] == false){
                txt_arrays[i-1][j-1][k-1] = txts8_scan_second[auto8];
                //ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
                JudgeConnectionSecond(i-1,j-1,k-1);
            }
          }
        }      
          
          }
        }
        
      }
    }
  }
  
}


//ターゲットの下隣(z-)との接続を判定
public void JudgeConnectionFirst(int i, int j, int k){
    //ターゲットの下隣(z-)との接続を判定
    if(   (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i][j][k-1].charAt(3) == '1')
       || (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i][j][k-1].charAt(2) == '1')
       || (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i][j][k-1].charAt(1) == '1')    
       || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i][j][k-1].charAt(0) == '1') ){
           found_voxel[i][j][k] = true;
          }else{
            found_voxel[i][j][k] = false;
            txt_arrays[i][j][k] = txts8_scan_first[0];
          } 
        }
        
//ターゲットの左隣(x-)、右隣(x+)、前隣(y-)、後隣(y+)、上隣(z+)との接続を判定
public void JudgeConnectionSecond(int i, int j, int k){
  if(   
     //ターゲットの左隣(x-)との接続を判定 
       (    (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i-1][j][k].charAt(6) == '1')
         || (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i-1][j][k].charAt(2) == '1')
         || (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i-1][j][k].charAt(4) == '1')    
         || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i-1][j][k].charAt(0) == '1') )
                  
     //ターゲットの右隣(x+)との接続を判定   
     ||(    (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i+1][j][k].charAt(7) == '1')
         || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i+1][j][k].charAt(3) == '1')
         || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i+1][j][k].charAt(5) == '1')    
         || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i+1][j][k].charAt(1) == '1') )
                  
     //ターゲットの前隣(y-)との接続を判定 
     ||(    (txt_arrays[i][j][k].charAt(7) == '1' && txt_arrays[i][j-1][k].charAt(5) == '1')
         || (txt_arrays[i][j][k].charAt(6) == '1' && txt_arrays[i][j-1][k].charAt(4) == '1')
         || (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i][j-1][k].charAt(1) == '1')    
         || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i][j-1][k].charAt(0) == '1') )
            
     //ターゲットの後隣(y+)との接続を判定
     ||(    (txt_arrays[i][j][k].charAt(5) == '1' && txt_arrays[i][j+1][k].charAt(7) == '1')
         || (txt_arrays[i][j][k].charAt(4) == '1' && txt_arrays[i][j+1][k].charAt(6) == '1')
         || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i][j+1][k].charAt(3) == '1')    
         || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i][j+1][k].charAt(2) == '1') )      
                   
     //ターゲットの上隣(z+)との接続を判定
     ||(    (txt_arrays[i][j][k].charAt(3) == '1' && txt_arrays[i][j][k+1].charAt(7) == '1')
         || (txt_arrays[i][j][k].charAt(2) == '1' && txt_arrays[i][j][k+1].charAt(6) == '1')
         || (txt_arrays[i][j][k].charAt(1) == '1' && txt_arrays[i][j][k+1].charAt(5) == '1')    
         || (txt_arrays[i][j][k].charAt(0) == '1' && txt_arrays[i][j][k+1].charAt(4) == '1') )
         ){
           found_voxel[i][j][k] = true;
         }else{
           found_voxel[i][j][k] = false;
           txt_arrays[i][j][k] = "00000000";
         }
       }




public void set_dithering_txt_arrays() {

  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1 || voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) {        
          /*dithering_c[0] = txt_arrays[i-1][j-1][k-1].charAt(4);
          dithering_c[1] = txt_arrays[i-1][j-1][k-1].charAt(5);
          dithering_c[2] = txt_arrays[i-1][j-1][k-1].charAt(6);
          dithering_c[3] = txt_arrays[i-1][j-1][k-1].charAt(7);
          dithering_c[4] = txt_arrays[i-1][j-1][k-1].charAt(0);
          dithering_c[5] = txt_arrays[i-1][j-1][k-1].charAt(1);
          dithering_c[6] = txt_arrays[i-1][j-1][k-1].charAt(2);
          dithering_c[7] = txt_arrays[i-1][j-1][k-1].charAt(3);*/
          
          dithering_c[0] = txt_arrays[i-1][j-1][k-1].charAt(7);
          dithering_c[1] = txt_arrays[i-1][j-1][k-1].charAt(6);
          dithering_c[2] = txt_arrays[i-1][j-1][k-1].charAt(5);
          dithering_c[3] = txt_arrays[i-1][j-1][k-1].charAt(4);
          dithering_c[4] = txt_arrays[i-1][j-1][k-1].charAt(3);
          dithering_c[5] = txt_arrays[i-1][j-1][k-1].charAt(2);
          dithering_c[6] = txt_arrays[i-1][j-1][k-1].charAt(1);
          dithering_c[7] = txt_arrays[i-1][j-1][k-1].charAt(0);

          dithering_txt_arrays[i-1][j-1][k-1] = new String(dithering_c);
        }
      }
    }
  }
}


public void set_dithering_xyzarrays() {
  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {
        if (voxelize_divide_xyzarrays[i+1][j+1][k+1] == 1 || voxelize_divide_xyzarrays[i+1][j+1][k+1] == 2) {        
          int count = 0;
          for (int g = 0; g<2; g = g + 1) {
            for (int f = 0; f<2; f = f + 1) {
              for (int e = 0; e<2; e = e + 1) {
                dithering_xyzarrays[(i-1)*2 + e][(j-1)*2 + f][(k-1)*2 + g] = dithering_txt_arrays[i-1][j-1][k-1].charAt(count) - '0';
                count++;
              }
            }
          }
        }
      }
    }
  }
}


public void set_xyzarrays_for_drawing() {
  for (int k = 1; k<=resolution*2; k = k + 1) {
    for (int j = 1; j<=resolution*2; j = j + 1) {
      for (int i = 1; i<=resolution*2; i = i + 1) {
        xyzarrays[i-1][j-1][k-1] = dithering_xyzarrays[i-1][j-1][k-1];
      }
    }
  }
}




/*
public void drawVoxelPattern(){
 for(int k = int((resolution-1)*z_scan/100)+1; k<=resolution; k = k + 1){
 for(int j = 1; j<=resolution; j = j + 1){
 for(int i = 1; i<=resolution; i = i + 1){
 
 //x
 float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
 float xx = -FIELD_SIZE + FIELD_STEP*(i);
 float realx = (x + xx)/2; 
 //y
 float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
 float yy = -FIELD_SIZE + FIELD_STEP*(j);
 float realy = (y + yy)/2; 
 //z
 float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
 float zz = -FIELD_SIZE + FIELD_STEP*(k);
 float realz = (z + zz)/2; 
 
 pushMatrix();
 translate(realx,realy,realz); 
 
 if(xyzarrays[i-1][j-1][k-1] == 1){
 txts0_count = 0;
 for(int g = 0; g <= 1; g++){
 for(int f = 0; f <= 1; f++){
 for(int e = 0; e <= 1; e++){
 pushMatrix();
 translate( - FIELD_STEP/4 + e*FIELD_STEP/2,
 - FIELD_STEP/4 + f*FIELD_STEP/2,
 - FIELD_STEP/4 + g*FIELD_STEP/2);
 if(txt_arrays[i-1][j-1][k-1].charAt(7-txts0_count) == '1'){
 stroke(0);
 fill(0,255,0,60);
 box(FIELD_STEP/2, FIELD_STEP/2, FIELD_STEP/2);
 }
 txts0_count++;
 popMatrix();
 }
 }
 }
 } 
 popMatrix();
 }
 }
 }
 }
 */
